SystemOrganization addCategory: #TinyChat!
SystemOrganization addCategory: #'TinyChat-Core'!
SystemOrganization addCategory: #'TinyChat-Manifest'!
SystemOrganization addCategory: #'TinyChat-Tests'!

PackageManifest subclass: #ManifestTinyChat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyChat-Manifest'!

!ManifestTinyChat commentStamp: '<historical>' prior: 0!
I store metadata for this package. These meta data are used by other tools such as the SmalllintManifestChecker and the critics Browser!

!ManifestTinyChat class methodsFor: 'code-critics' stamp: 'PeterPesch 7/3/2020 17:13'!
ruleReTestClassNotInPackageWithTestEndingNameV1FalsePositive
	^ #(#(#(#RGClassDefinition #(#TCMessageTest)) #'2020-07-03T17:13:51.98914+02:00') )! !

TestCase subclass: #TCMessageTest
	instanceVariableNames: 'emptyMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyChat-Tests'!

!TCMessageTest methodsFor: 'tests' stamp: 'PeterPesch 7/3/2020 17:13'!
dontTestSeparator
	"Skip this test for now, because it only uses private instance variables."
	| mySeparator |
	mySeparator := '|'.
	self assert: (emptyMessage instVarNamed: 'separator') equals: '>'.
	self deny: (emptyMessage instVarNamed: 'separator') equals: mySeparator.
	emptyMessage instVarNamed: 'separator' put: mySeparator.
	self assert: (emptyMessage instVarNamed: 'separator') equals: mySeparator! !

!TCMessageTest methodsFor: 'running' stamp: 'PeterPesch 7/3/2020 17:02'!
setUp
	"Hooks that subclasses may override to define the fixture of test."
	super setUp.
	emptyMessage := TCMessage new
! !

!TCMessageTest methodsFor: 'tests' stamp: 'PeterPesch 7/3/2020 17:44'!
testFromString
	| mySender myText myString myMessage |
	mySender := 'oivier'.
	myText := 'tinychat is cool'.
	myMessage := TCMessage new.
	myString := mySender, (myMessage instVarNamed: 'separator'), myText.
	"First test the Instance Method:"
	myMessage := myMessage fromString: myString.
	self assert: myMessage sender equals: mySender.
	self assert: myMessage text equals: myText.
	"Now test the class method:"
	myMessage := nil.
	myMessage := TCMessage fromString: myString.
	self assert: myMessage sender equals: mySender.
	self assert: myMessage text equals: myText! !

!TCMessageTest methodsFor: 'tests' stamp: 'PeterPesch 7/3/2020 17:17'!
testFromText
	| mySender myText myMessage |
	mySender := 'IAmTheSender'.
	myText := 'This is the text of my message!!'.
	myMessage := TCMessage from: mySender text: myText.
	self assert: myMessage sender equals: mySender.
	self assert: myMessage text equals: myText ! !

!TCMessageTest methodsFor: 'tests' stamp: 'PeterPesch 7/3/2020 17:04'!
testSender
	| mySender |
	mySender := 'This is my Sender'.
	self deny: emptyMessage sender equals: mySender.
	emptyMessage sender: mySender.
	self assert: emptyMessage sender equals: mySender! !

!TCMessageTest methodsFor: 'tests' stamp: 'PeterPesch 7/3/2020 17:05'!
testText
	| myText |
	myText := 'This is my Text'.
	self deny: emptyMessage text equals: myText.
	emptyMessage text: myText.
	self assert: emptyMessage text equals: myText! !

Object subclass: #TCMessage
	instanceVariableNames: 'sender text separator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyChat-Core'!

!TCMessage commentStamp: 'PeterPesch 7/3/2020 16:56' prior: 0!
I represent a Message in the Chat.
!

!TCMessage class methodsFor: 'instance creation' stamp: 'PeterPesch 7/3/2020 16:56'!
from: aSender text: aText
	^ self new
		sender: aSender;
		text: aText;
		yourself! !

!TCMessage class methodsFor: 'instance creation' stamp: 'PeterPesch 7/3/2020 17:45'!
fromString: aString 
	^ self new
		fromString: aString;
		yourself! !

!TCMessage methodsFor: 'creation' stamp: 'PeterPesch 7/3/2020 17:40'!
fromString: aString 
	"Compose a message from a string of this form 'sender>message'."
	| items |
	items := aString splitOn: separator.
	self sender: items first.
	self text: items second.! !

!TCMessage methodsFor: 'initialization' stamp: 'PeterPesch 7/3/2020 16:55'!
initialize
	super initialize.
	separator := '>'.! !

!TCMessage methodsFor: 'printing' stamp: 'PeterPesch 7/3/2020 16:57'!
printOn: aStream
	aStream
	<< self sender; << separator;
	<< self text; << String crlf! !

!TCMessage methodsFor: 'accessing' stamp: 'PeterPesch 7/3/2020 16:52'!
sender
	^ sender! !

!TCMessage methodsFor: 'accessing' stamp: 'PeterPesch 7/3/2020 16:53'!
sender: anObject
	sender := anObject! !

!TCMessage methodsFor: 'accessing' stamp: 'PeterPesch 7/3/2020 16:53'!
text
	^ text! !

!TCMessage methodsFor: 'accessing' stamp: 'PeterPesch 7/3/2020 16:53'!
text: anObject
	text := anObject! !
